Contributing
============

Contributions are welcome, and they are greatly appreciated! Every
little bit helps, and credit will always be given.

Bug reports
-----------

When [reporting a bug](https://gitlab.com/johnlage/Cipher/issues) please
include:

> -   Your operating system name and version.
> -   Any details about your local setup that might be helpful in
>     troubleshooting.
> -   Detailed steps to reproduce the bug.

Documentation improvements
--------------------------

Cipher could always use more documentation, whether as part of the
official Cipher docs, in docstrings, or even on the web in blog posts,
articles, and such.

Feature requests and feedback
-----------------------------

The best way to send feedback is to file an issue at
<https://gitlab.com/johnlage/Cipher/issues>.

If you are proposing a feature:

-   Explain in detail how it would work.
-   Keep the scope as narrow as possible, to make it easier to
    implement.
-   Remember that this is a volunteer-driven project, and that code
    contributions are welcome :)

Development
-----------

To set up Cipher for local development:

1.  Fork [Cipher](https://gitlab.com/johnlage/Cipher) (look for the
    \"Fork\" button).
2.  Clone your fork locally:

    ```commandline
    git clone git@gitlab.com:your_name_here/Cipher.git
    ```

3.  Create a branch for local development:

    ```commandline
    git checkout -b name-of-your-bugfix-or-feature
    ```

    Now you can make your changes locally.

4.  Commit your changes and push your branch to GitLab:

    ```commandline
    git add .
    git commit -m "Your detailed description of your changes."
    git push origin name-of-your-bugfix-or-feature
    ```
    
5.  Submit a pull request through the GitLab website.

### Pull Request Guidelines

If you need some code review or feedback while you\'re developing the
code just make the pull request.

For merging, you should:

1.  Update documentation when there\'s new API, functionality etc.
2.  Add a note to `CHANGELOG.md` about the changes.
3.  Add yourself to `AUTHORS.md`.
